#!/bin/bash                                                                                                                                                                                                                                                    

set -e

INSTPREFIX="$1"

VER=8.2.0.1
WORKDIR=${PWD}
TOPDIR0=/opt/ghcjs/8.2.0.1/lib/ghcjs

BINDIR=${INSTPREFIX}/opt/ghcjs/8.2.0.1/bin
TOPDIR=${INSTPREFIX}${TOPDIR0}

if [ ! -f "${PWD}/cabal.rc" ]; then
    echo "cabal.rc not found in pwd ($PWD)"
    exit 1
fi

mkdir -p /tmp/cabal

rm -rf "$INSTPREFIX"
mkdir -p "${BINDIR}"

for N in ghcjs ghcjs-pkg haddock-ghcjs hsc2hs-ghcjs; do
    sed "s|@TOPDIR@|$TOPDIR|g" "./wrappers/$N.in" > "$BINDIR/$N"
    chmod +x "$BINDIR/$N"
done

mkdir -p $TOPDIR/bin
for N in ghcjs ghcjs-pkg haddock-ghcjs hsc2hs-ghcjs; do
    cp -v /opt/ghcjs/8.2.0.1/lib/ghcjs/bin/$N $TOPDIR/bin/$N
done

HOME=/tmp/cabal CABAL_CONFIG="${PWD}/cabal.rc" PATH="${INSTPREFIX}/opt/ghcjs/8.2.0.1/bin:/opt/ghc/8.2.2/bin:$PATH" \
    /opt/ghcjs/8.2.0.1/lib/ghcjs/bin/ghcjs-boot -s /opt/ghcjs/8.2.0.1/lib/ghcjs/boot.tar \
    --no-prof --no-haddock \
    --with-ghcjs-run /opt/ghcjs/8.2.0.1/lib/ghcjs/bin/ghcjs-run \
    --with-cabal /opt/cabal/head/bin/cabal

# fixup installation                                                                                                                                                                                                                                           

## fixup database                                                                                                                                                                                                                                              
sed -i "s|$TOPDIR|\${pkgroot}|g" "${TOPDIR}/package.conf.d"/*.conf
"$BINDIR/ghcjs-pkg" recache -v

## remove redundant stuff                                                                                                                                                                                                                                      
rm -rf "$TOPDIR/boot"

## create proper wrappers
for N in ghcjs ghcjs-pkg haddock-ghcjs hsc2hs-ghcjs; do
    rm -fv "$BINDIR/$N"
    sed "s|@TOPDIR@|$TOPDIR0|g" "./wrappers/$N.in" > "$BINDIR/$N-$VER"
    chmod +x "$BINDIR/$N-$VER"
done

exit 0
